  DEFINT A-Z
  REDIM Table&(255)
  CONST Num$ = "0123456789ABCDEF"
  F1$ = CHR$(0) + ";"
  SCREEN 0
  VIEW PRINT
  COLOR 14
  CLS
  LOCATE 1, 32
  COLOR 9
  PRINT "CRC32 CALCULATOR"
  LOCATE 3, 1, 1
  COLOR 14
  PRINT "<C>";
  COLOR 2
  PRINT "ustom Seed or ";
  COLOR 14
  PRINT "<W>";
  COLOR 2
  PRINT "inZip/PKZip Seed or ";
  COLOR 14
  PRINT "<Esc> ";
  COLOR 2
  PRINT "to EXIT Program: ";
  COLOR 14
  DO
    Choice$ = UCASE$(INKEY$)
    IF LEN(Choice$) THEN
      IF Choice$ = CHR$(27) THEN
        VIEW PRINT
        COLOR 7
        CLS
        SYSTEM
      ELSEIF INSTR("CW", Choice$) THEN
        EXIT DO
      END IF
    END IF
  LOOP
  PRINT "<"; Choice$; ">";
  VIEW PRINT 5 TO 24
  IF Choice$ = "W" THEN
    Seed& = &HEDB88320
    GOTO Table
  END IF
CustomSeed:
  CLS
  LOCATE 5, 1
  COLOR 2
  PRINT "Enter Seed (8-Digit Hex): ";
  COLOR 14
  LINE INPUT ; "", Seed$
  Seed$ = LTRIM$(RTRIM$(UCASE$(Seed$)))
  IF Seed$ = "" THEN
    RUN
  ELSEIF LEN(Seed$) <> 8 THEN
    GOTO CustomSeed
  END IF
  FOR X = 1 TO LEN(Seed$)
    IF INSTR(Num$, MID$(Seed$, X, 1)) = 0 THEN
      GOTO CustomSeed
    END IF
  NEXT X
  Seed$ = "&H" + Seed$
  Seed& = VAL(Seed$)
  IF MID$(Seed$, 3, 4) = "0000" THEN
    Seed$ = MKL$(Seed&)
    Seed$ = LEFT$(Seed$, 2) + STRING$(2, 0)
    Seed& = CVL(Seed$)
  END IF
Table:
  CLS
  LOCATE 5, 33
  COLOR 2
  PRINT "Seed: ";
  COLOR 14
  PRINT STRING$(8 - LEN(HEX$(Seed&)), "0"); HEX$(Seed&)
  COLOR 2
  PRINT STRING$(80, 196);
  FOR Byte = 0 TO 255
    CRC& = Byte
    FOR Bit = 0 TO 7
      TempCRC32& = CRC& AND &HFFFFFFFE
      TempCRC32& = TempCRC32& \ &H2
      TempCRC32& = TempCRC32& AND &H7FFFFFFF
      IF (CRC& AND &H1) <> 0 THEN
        CRC& = TempCRC32& XOR Seed&
      ELSE
        CRC& = TempCRC32&
      END IF
    NEXT Bit
    Table&(Byte) = CRC&
  NEXT Byte
  '
  '**************************************************************************
  '
Begin:
  Register& = &HFFFFFFFF
  VIEW PRINT 7 TO 24
  COLOR 14
  CLS
  LOCATE 9, 1
  COLOR 2
  PRINT "Calculate for ";
  COLOR 14
  PRINT "<F>";
  COLOR 2
  PRINT "ile or ";
  COLOR 14
  PRINT "<S>";
  COLOR 2
  PRINT "tring or ";
  COLOR 14
  PRINT "<Esc> ";
  COLOR 2
  PRINT "to RE-START Program: ";
  COLOR 14
  DO
    Choice$ = UCASE$(INKEY$)
    IF LEN(Choice$) THEN
      IF Choice$ = CHR$(27) THEN
        RUN
      ELSEIF INSTR("FS", Choice$) THEN
        EXIT DO
      END IF
    END IF
  LOOP
  PRINT "<"; Choice$; ">";
  LOCATE 10, 1
  COLOR 2
  PRINT STRING$(80, 196);
  LOCATE 12, 1
  IF Choice$ = "F" THEN
    GOTO GetFile
  END IF
  PRINT "Key-In a String  ";
  COLOR 14
  PRINT " <F1> ";
  COLOR 2
  PRINT "to Reverse String or";
  COLOR 14
  PRINT " <Esc> ";
  COLOR 2
  PRINT "if DONE:";
  TheRow = 14
  TheCol = 1
  VIEW PRINT 14 TO 24
  COLOR 14
  CLS
  '
  '**************************************************************************
  '
Text:
  DO
    LOCATE TheRow, TheCol
    Byte$ = INKEY$
    IF LEN(Byte$) = 2 AND LEN(StoredByte$) THEN
      IF Byte$ = F1$ THEN
        GOTO Backwards
      END IF
    ELSEIF LEN(Byte$) = 1 THEN
      IF Byte$ = CHR$(27) THEN
        StoredByte$ = ""
        GOTO Begin
      ELSEIF Byte$ = CHR$(8) AND LEN(StoredByte$) THEN
        CLS
        TheRow = CSRLIN
        TheCol = POS(0)
        Register& = &HFFFFFFFF
        IF LEN(StoredByte$) = 1 THEN
          StoredByte$ = ""
          CLS
          GOTO Text
        ELSE
          StoredByte$ = LEFT$(StoredByte$, LEN(StoredByte$) - 1)
        END IF
        FOR X = 1 TO LEN(StoredByte$)
          Byte$ = MID$(StoredByte$, X, 1)
          LOCATE TheRow, TheCol
          PRINT Byte$;
          TheRow = CSRLIN
          TheCol = POS(0)
          GOSUB Procedure
          IF Byte$ = CHR$(13) THEN
            Byte$ = CHR$(10)
            GOSUB Procedure
          END IF
        NEXT X
        GOSUB CurrentCRC
      ELSEIF ASC(Byte$) = 9 OR ASC(Byte$) = 10 THEN
        EXIT DO
      ELSEIF ASC(Byte$) = 13 THEN
        PRINT
        TheRow = CSRLIN
        TheCol = POS(0)
        Byte$ = CHR$(13)
        GOSUB Procedure
        Byte$ = CHR$(10)
        GOSUB Procedure
        GOSUB CurrentCRC
        StoredByte$ = StoredByte$ + CHR$(13)
      ELSEIF ASC(Byte$) > 31 THEN
        EXIT DO
      END IF
    END IF
  LOOP
  StoredByte$ = StoredByte$ + Byte$
  PRINT Byte$;
  TheRow = CSRLIN
  TheCol = POS(0)
  GOSUB Procedure
  GOSUB CurrentCRC
  GOTO Text
  '
  '**************************************************************************
  '
Backwards:
  VIEW PRINT 12 TO 24
  CLS
  COLOR 2
  PRINT "String in Reverse  ";
  COLOR 14
  PRINT "<Esc> ";
  COLOR 2
  PRINT "to CLEAR:";
  VIEW PRINT 14 TO 24
  COLOR 14
  CLS
  Register& = &HFFFFFFFF
  FOR X = LEN(StoredByte$) TO 1 STEP -1
    Byte$ = MID$(StoredByte$, X, 1)
    PRINT Byte$;
    TheRow = CSRLIN
    TheCol = POS(0)
    GOSUB Procedure
  NEXT X
  GOSUB CurrentCRC
  StoredByte$ = ""
  LOCATE TheRow, TheCol
  DO
    An$ = INKEY$
    IF LEN(An$) THEN
      IF An$ = CHR$(27) THEN
        GOTO Begin
      END IF
    END IF
  LOOP
GetFile:
  VIEW PRINT 12 TO 24
  COLOR 14
  CLS
  PRINT "[d:][\path\]filename.ext <Enter> ";
  COLOR 2
  PRINT "or ";
  COLOR 14
  PRINT "<Enter> ";
  COLOR 2
  PRINT "to GO-BACK: ";
  LOCATE 14, 1
  COLOR 14
  LINE INPUT ; "", FileName$
  FileName$ = UCASE$(LTRIM$(RTRIM$(FileName$)))
  IF FileName$ = "" THEN
    GOTO Begin
  ELSEIF LEN(DIR$(FileName$)) = 0 THEN
    GOTO GetFile
  END IF
  VIEW PRINT 14 TO 24
  CLS
  PRINT FileName$;
  LOCATE 19, 1
  COLOR 2
  PRINT "Working....";
  FileName = FREEFILE
  OPEN "B", FileName, FileName$
  FileLength& = LOF(FileName)
  Chunks& = FileLength& \ 32766
  Remainder = (FileLength& - (Chunks& * 32766))
  IF Chunks& THEN
    StoredByte$ = STRING$(32766, 32)
    FOR X& = 1 TO Chunks&
      GET #FileName, , StoredByte$
      FOR Y = 1 TO 32766
        Byte$ = MID$(StoredByte$, Y, 1)
        GOSUB Procedure
      NEXT Y
    NEXT X&
  END IF
  IF Remainder THEN
    StoredByte$ = STRING$(Remainder, 32)
    GET #FileName, , StoredByte$
    FOR Y = 1 TO Remainder
      Byte$ = MID$(StoredByte$, Y, 1)
      GOSUB Procedure
    NEXT Y
  END IF
  CLOSE FileName
  StoredByte$ = ""
  GOSUB CurrentCRC
  LOCATE 19, 1
  PRINT "<Esc>";
  COLOR 2
  PRINT " to CLEAR";
  DO
    An$ = INKEY$
    IF LEN(An$) THEN
      IF An$ = CHR$(27) THEN
        EXIT DO
      END IF
    END IF
  LOOP
  GOTO Begin
  '
  '**************************************************************************
  '
Procedure:
  RegisterByte$ = MKL$(Register&)
  IndexByte$ = LEFT$(RegisterByte$, 1) + CHR$(0)   '*** LOW byte of Register
  IndexByte = CVI(IndexByte$)                      '*** converted to integer.
  IndexByte = IndexByte XOR ASC(Byte$)
  '
  '**** Shift the HIGH three bytes of the Register DOWN & pad with a CHR$(0).
  '
  RegisterByte$ = RIGHT$(RegisterByte$, 3) + CHR$(0)
  Register& = CVL(RegisterByte$)
  '
  '*** XOR the Register with the value in the Table at the IndexByte.
  '
  Register& = Register& XOR Table&(IndexByte)
  RETURN
  '
  '**************************************************************************
  '
CurrentCRC:
  CurrentCRC& = Register& XOR &HFFFFFFFF
  LOCATE 25, 1
  COLOR 2
  IF Choice$ = "F" THEN
    PRINT "File";
  ELSE
    PRINT "Current";
  END IF
  PRINT " CRC: ";
  COLOR 14
  PRINT HEX$(CurrentCRC&); " Hex"; SPC(5); TAB(40); CurrentCRC&; "Decimal"; SPC(5);
  RETURN

