  DEFINT A-Z
  REDIM Table&(255)
  CONST Num$ = "0123456789ABCDEF"
  SCREEN 0
  VIEW PRINT
  COLOR 14
  CLS
  LOCATE 1, 29
  COLOR 9
  PRINT "CRC32 TABLE CALCULATOR"
  LOCATE 3, 1, 1
  COLOR 14
  PRINT "<C>";
  COLOR 2
  PRINT "ustom Seed or ";
  COLOR 14
  PRINT "<W>";
  COLOR 2
  PRINT "inZip/PKZip Seed or ";
  COLOR 14
  PRINT "<Esc> ";
  COLOR 2
  PRINT "to EXIT Program: ";
  COLOR 14
  DO
    Choice$ = UCASE$(INKEY$)
    IF LEN(Choice$) THEN
      IF Choice$ = CHR$(27) THEN
        VIEW PRINT
        COLOR 7
        CLS
        SYSTEM
      ELSEIF INSTR("CW", Choice$) THEN
        EXIT DO
      END IF
    END IF
  LOOP
  PRINT "<"; Choice$; ">";
  VIEW PRINT 5 TO 24
  IF Choice$ = "W" THEN
    Seed& = &HEDB88320
    GOTO Table
  END IF
CustomSeed:
  CLS
  LOCATE 5, 1
  COLOR 2
  PRINT "Enter Seed (8-Digit Hex): ";
  COLOR 14
  LINE INPUT ; "", Seed$
  Seed$ = LTRIM$(RTRIM$(UCASE$(Seed$)))
  IF Seed$ = "" THEN
    RUN
  ELSEIF LEN(Seed$) <> 8 THEN
    GOTO CustomSeed
  END IF
  FOR X = 1 TO LEN(Seed$)
    IF INSTR(Num$, MID$(Seed$, X, 1)) = 0 THEN
      GOTO CustomSeed
    END IF
  NEXT X
  Seed$ = "&H" + Seed$
  Seed& = VAL(Seed$)
  IF MID$(Seed$, 3, 4) = "0000" THEN
    Seed$ = MKL$(Seed&)
    Seed$ = LEFT$(Seed$, 2) + STRING$(2, 0)
    Seed& = CVL(Seed$)
  END IF
Table:
  CLS
  LOCATE 5, 33
  COLOR 2
  PRINT "Seed: ";
  COLOR 14
  PRINT STRING$(8 - LEN(HEX$(Seed&)), "0"); HEX$(Seed&)
  COLOR 2
  PRINT STRING$(80, 196);
  FOR Byte = 0 TO 255
    CRC& = Byte
    FOR Bit = 0 TO 7
      TempCRC32& = CRC& AND &HFFFFFFFE
      TempCRC32& = TempCRC32& \ &H2
      TempCRC32& = TempCRC32& AND &H7FFFFFFF
      IF (CRC& AND &H1) <> 0 THEN
        CRC& = TempCRC32& XOR Seed&
      ELSE
        CRC& = TempCRC32&
      END IF
    NEXT Bit
    Table&(Byte) = CRC&
  NEXT Byte
  '

'***********************
  VIEW PRINT 7 TO 24
  COLOR 14
  CLS
  Page = 1
  FOR X = 0 TO 255
    IF LEN(HEX$(Table&(X))) < 8 THEN
     A$ = STRING$(8 - LEN(HEX$(Table&(X))), "0")
    END IF
    A$ = A$ + HEX$(Table&(X))
    IF POS(0) < 10 THEN
      PRINT TAB(15);
    END IF
    PRINT A$; " ",
    A$ = ""
    IF POS(0) > 60 THEN
      PRINT
    END IF
    IF CSRLIN = 23 THEN
      LOCATE 24, 34, 0
      COLOR 2
      PRINT "Page";
      COLOR 14
      PRINT Page;
      COLOR 2
      PRINT "of";
      COLOR 14
      PRINT " 4";
      WHILE INKEY$ = ""
      WEND
      CLS
      Page = Page + 1
    END IF
  NEXT X
  RUN

